Index: pcp/src/wannier.c
===================================================================
--- pcp/src/wannier.c	(revision 9bdd866eca950981175d4eb672952e1c119b1d98)
+++ pcp/src/wannier.c	(revision 4f136930622a3ef24a8e10066443133f1c24c77c)
@@ -1042,187 +1814,9 @@
       OpenFile(P, &F->SpreadFile, suffix, "a", P->Call.out[ReadOut]); // only open on starting level
     if (F->SpreadFile == NULL) {
-      Error(SomeError,"ComputeMLWF: Error opening Wannier File!\n");
+      Error(SomeError,"WriteWannierFile: Error opening Wannier File!\n");
     } else {
       fprintf(F->SpreadFile,"#===== W A N N I E R  C E N T R E S for Level %d of type %s ========================\n", R->LevSNo, spin);
       fprintf(F->SpreadFile,"# Orbital+Level\tx\ty\tz\tSpread\n");
     }
-  }
-  old_spread = 0;
-  spread = 0;
-  i=-1;
-  for (l=0; l < Psi->MaxPsiOfType+P->Par.Max_me_comm_ST_PsiT; l++) {  // go through all wave functions
-    OnePsiA = &Psi->AllPsiStatus[l];    // grab OnePsiA
-    if (OnePsiA->PsiType == type) {   // drop all but occupied ones
-      i++;  // increase l if it is occupied wave function
-      //fprintf(stderr,"(%i) Wannier for %i\n", P->Par.me, i);
-      
-      // calculate Wannier Centre
-      for (j=0;j<NDIM;j++) {
-        WannierCentre[i][j] = sqrt(Lat->RealBasisSQ[j])/(2*PI) * GSL_IMAG( gsl_complex_log( gsl_complex_rect(gsl_matrix_get(A[j*2],i,i),gsl_matrix_get(A[j*2+1],i,i))));
-        if (WannierCentre[i][j] < 0) // change wrap around of above operator to smooth 0...Lat->RealBasisSQ
-          WannierCentre[i][j] = sqrt(Lat->RealBasisSQ[j]) + WannierCentre[i][j];
-      }
-      
-      // store orbital spread and centre in file
-      tmp = - pow(gsl_matrix_get(A[0],i,i),2) - pow(gsl_matrix_get(A[1],i,i),2)
-            - pow(gsl_matrix_get(A[2],i,i),2) - pow(gsl_matrix_get(A[3],i,i),2)
-            - pow(gsl_matrix_get(A[4],i,i),2) - pow(gsl_matrix_get(A[5],i,i),2);          
-      WannierSpread[i] = gsl_matrix_get(A[max_operators],i,i) + tmp; 
-      //fprintf(stderr,"(%i) WannierSpread[%i] = %e\n", P->Par.me, i, WannierSpread[i]);
-      //if (P->Par.me == 0) fprintf(F->SpreadFile,"Orbital %d:\t Wannier center (x,y,z)=(%lg,%lg,%lg)\t Spread sigma^2 = %lg - %lg = %lg\n",
-        //Psi->AllPsiStatus[i].MyGlobalNo, WannierCentre[i][0], WannierCentre[i][1], WannierCentre[i][2], gsl_matrix_get(A[max_operators],i,i), -tmp, WannierSpread[i]); 
-      //if (P->Par.me == 0) fprintf(F->SpreadFile,"%e\t%e\t%e\n",
-        //WannierCentre[i][0], WannierCentre[i][1], WannierCentre[i][2]);
-      
-      // gather all spreads
-      old_spread += gsl_matrix_get(A[max_operators],i,i); // tr(U^H B U)
-      for (k=0;k<max_operators;k++)
-        spread += pow(gsl_matrix_get(A[k],i,i),2);
-
-      // store calculated Wannier centre
-      if (OnePsiA->my_color_comm_ST_Psi == P->Par.my_color_comm_ST_Psi) // is this local?
-        for (j=0;j<NDIM;j++)
-          Psi->AddData[OnePsiA->MyLocalNo].WannierCentre[j] = WannierCentre[i][j];
-    }
-  }
-  
-  // join Wannier orbital to groups with common centres under certain conditions 
-  switch (R->CommonWannier) {
-   case 4:
-    debug(P,"Shifting each Wannier centers to cell center");
-    for (i=0; i < Num; i++) {  // go through all occupied wave functions
-      for (j=0;j<NDIM;j++)
-        WannierCentre[i][j] = sqrt(Lat->RealBasisSQ[j])/2.; 
-    }    
-    break;
-   case 3:
-    debug(P,"Shifting Wannier centers individually to nearest grid point");
-    for (i=0;i < Num; i++) {  // go through all wave functions
-      for (j=0;j<NDIM;j++) {
-        tmp = WannierCentre[i][j]/sqrt(Lat->RealBasisSQ[j])*(double)N[j];
-        //fprintf(stderr,"(%i) N[%i]: %i\t tmp %e\t floor %e\t ceil %e\n",P->Par.me, j, N[j], tmp, floor(tmp), ceil(tmp));
-        if (fabs((double)floor(tmp) - tmp) < fabs((double)ceil(tmp) - tmp))
-          WannierCentre[i][j] = (double)floor(tmp)/(double)N[j]*sqrt(Lat->RealBasisSQ[j]); 
-        else
-          WannierCentre[i][j] = (double)ceil(tmp)/(double)N[j]*sqrt(Lat->RealBasisSQ[j]); 
-      }
-    }
-    break;
-   case 2:
-    debug(P,"Combining individual orbitals according to spread.");
-    //fprintf(stderr,"(%i) Finding multiple bindings and Reweighting Wannier centres\n",P->Par.me);
-    //debug(P,"finding partners");
-    marker = (int*) Malloc(sizeof(int)*(Num+1),"ComputeMLWF: marker");
-    group = (int**) Malloc(sizeof(int *)*Num,"ComputeMLWF: group");
-    for (l=0;l<Num;l++) {
-      group[l] = (int*) Malloc(sizeof(int)*(Num+1),"ComputeMLWF: group[l]");  // each must group must have one more as end marker
-      for (k=0;k<=Num;k++)
-        group[l][k] = -1; // reset partner group
-    }
-    for (k=0;k<Num;k++)
-      partner[k] = 0;
-    //debug(P,"mem allocated");
-    // go for each orbital through every other, check distance against the sum of both spreads
-    // if smaller add to group of this orbital
-    for (l=0;l<Num;l++) {
-      j=0;  // index for partner group
-      for (k=0;k<Num;k++) {  // check this against l
-        Spread = 0.;
-        for (i=0;i<NDIM;i++) {
-          //fprintf(stderr,"(%i) Spread += (%e - %e)^2 \n", P->Par.me, WannierCentre[l][i], WannierCentre[k][i]); 
-          Spread += (WannierCentre[l][i] - WannierCentre[k][i])*(WannierCentre[l][i] - WannierCentre[k][i]);
-        }
-        Spread = sqrt(Spread);  // distance in Spread
-        //fprintf(stderr,"(%i) %i to %i: distance %e, SpreadSum = %e + %e = %e \n", P->Par.me, l, k, Spread, WannierSpread[l], WannierSpread[k], WannierSpread[l]+WannierSpread[k]); 
-        if (Spread < 1.5*(WannierSpread[l]+WannierSpread[k])) {// if distance smaller than sum of spread
-          group[l][j++] = k;  // add k to group of l
-          partner[l]++;
-          //fprintf(stderr,"(%i) %i added as %i-th member to %i's group.\n", P->Par.me, k, j, l);
-        } 
-      }
-    }
-    
-    // consistency, for each orbital check if this orbital is also in the group of each referred orbital
-    //debug(P,"checking consistency");
-    totalflag = 1;
-    for (l=0;l<Num;l++) // checking l's group
-      for (k=0;k<Num;k++) { // k is partner index
-        if (group[l][k] != -1) {  // if current index k is a partner
-          flag = 0;
-          for(j=0;j<Num;j++) {  // go through each entry in l partner's partner group if l exists
-            if ((group[ group[l][k] ][j] == l))
-              flag = 1;
-          }
-          //if (flag == 0) fprintf(stderr, "(%i) in %i's group %i is referred as a partner, but not the other way round!\n", P->Par.me, l, group[l][k]);
-          if (totalflag == 1) totalflag = flag;
-        }
-      }
-    // for each orbital group (marker group) weight each center to a total and put this into the local WannierCentres
-    //debug(P,"weight and calculate new centers for partner groups");
-    for (l=0;l<=Num;l++)
-      marker[l] = 1;
-    if (totalflag) {
-      for (l=0;l<Num;l++) { // go through each orbital
-        if (marker[l] != 0) { // if it hasn't been reweighted
-          marker[l] = 0;
-          for (i=0;i<NDIM;i++) 
-            q[i] = 0.;
-          j = 0;
-          while (group[l][j] != -1) {
-            marker[group[l][j]] = 0;
-            for (i=0;i<NDIM;i++) {
-              //fprintf(stderr,"(%i) Adding to %i's group, %i entry of %i: %e\n", P->Par.me, l, i, group[l][j], WannierCentre[ group[l][j] ][i]);
-              q[i] += WannierCentre[ group[l][j] ][i];
-            } 
-            j++;
-          }
-          //fprintf(stderr,"(%i) %i's group: (%e,%e,%e)/%i = (%e,%e,%e)\n", P->Par.me, l, q[0], q[1], q[2], j, q[0]/(double)j, q[1]/(double)j, q[2]/(double)j);
-          for (i=0;i<NDIM;i++) {// weight by number of elements in partner group
-            q[i] /= (double)(j);
-          }
-  
-          // put WannierCentre into own and all partners'      
-          for (i=0;i<NDIM;i++)
-            WannierCentre[l][i] = q[i];
-          j = 0;  
-          while (group[l][j] != -1) {
-            for (i=0;i<NDIM;i++)
-              WannierCentre[group[l][j]][i] = q[i];
-            j++;
-          }
-        }
-      }
-    }
-    if (P->Call.out[StepLeaderOut]) {
-      fprintf(stderr,"Summary:\n");
-      fprintf(stderr,"========\n");
-      for (i=0;i<Num;i++)
-        fprintf(stderr,"%i belongs to a %i-ple binding.\n",i,partner[i]);
-    } 
-    //debug(P,"done");
-  
-    Free(marker, "bla");
-    for (l=0;l<Num;l++)
-      Free(group[l], "bla");
-    Free(group, "bla");
-    break;
-   case 1:
-    debug(P,"Individual orbitals are changed to center of all.");
-    for (i=0;i<NDIM;i++)  // zero center of weight
-      q[i] = 0.;
-    for (k=0;k<Num;k++)
-      for (i=0;i<NDIM;i++) {  // sum up all orbitals each component
-        q[i] += WannierCentre[k][i];
-      }
-    for (i=0;i<NDIM;i++)  // divide by number
-      q[i] /= Num;
-    for (k=0;k<Num;k++)
-      for (i=0;i<NDIM;i++) {  // put into this function's array
-        WannierCentre[k][i] = q[i];
-      }
-    break;
-   case 0:
-   default:
-   break;
   }
   
@@ -1244,23 +1838,8 @@
     fprintf(F->SpreadFile,"\n#Matrix traces\tB_ii\tA_ii^2\tTotal (B_ii - A_ii^2)\n");
     fprintf(F->SpreadFile,"TotalSpread_L%d\t%lg\t%lg\t%lg\n\n",R->LevSNo, old_spread, spread, old_spread - spread);
-  }
-  fflush(F->SpreadFile);
-
-  // and the spread was calculated in the loop above
-/*
-  i=-1;     
-  for (l=0;l<Psi->MaxPsiOfType+P->Par.Max_me_comm_ST_PsiT;l++)
-    if (Psi->AllPsiStatus[l].PsiType == type) {
-      i++;
-      spread = CalculateSpread(P,l);
-      tmp = gsl_matrix_get(A[max_operators],i,i) - pow(gsl_matrix_get(A[0],i,i),2) - pow(gsl_matrix_get(A[1],i,i),2)
-          - pow(gsl_matrix_get(A[2],i,i),2) - pow(gsl_matrix_get(A[3],i,i),2)
-          - pow(gsl_matrix_get(A[4],i,i),2) - pow(gsl_matrix_get(A[5],i,i),2);
-      if(P->Call.out[ValueOut]) fprintf(stderr, "(%i) Check of spread of %ith wave function: %lg against %lg\n",P->Par.me, i, Psi->AddData[i].WannierSpread, tmp);  
-    }*/
-  // free all remaining memory
-  for (k=0;k<max_operators+1;k++)
-    gsl_matrix_free(A[k]);
-}
+    fflush(F->SpreadFile);
+  }
+}
+
 
 /** Parses the spread file and puts values into OnePsiElementAddData#WannierCentre.
@@ -1280,18 +1859,18 @@
   double WannierCentre[NDIM+1]; // combined centre and spread
   MPI_Status status;
-  enum PsiTypeTag type = Occupied;
   int signal = 0; // 1 - ok, 0 - error
 
   switch (Lat->Psi.PsiST) {
   case SpinDouble:
-    strncpy(suffix,".spread.csv",18);    
+    strcpy(suffix,".spread.csv");    
     break;
   case SpinUp:
-    strncpy(suffix,".spread_up.csv",18);    
+    strcpy(suffix,".spread_up.csv");    
     break;
   case SpinDown:
-    strncpy(suffix,".spread_down.csv",18);    
+    strcpy(suffix,".spread_down.csv");    
     break;
   }
+  if (P->Call.out[NormalOut]) fprintf(stderr,"(%i) Parsing Wannier Centres from file ... \n", P->Par.me);
   
   if (P->Par.me_comm_ST == 0) { 
@@ -1354,8 +1933,8 @@
           //return 0;
         // and store 'em (for all who have this Psi local)
-        fprintf(stderr,"(%i) Psi %i, L %i: (x,y,z) = (%lg, %lg, %lg), Spread %lg\n",P->Par.me,i, R->LevSNo, WannierCentre[0], WannierCentre[1], WannierCentre[2], WannierCentre[NDIM]);
+        if ((P->Par.me == 0) && P->Call.out[ValueOut]) fprintf(stderr,"(%i) Psi %i, L %i: (x,y,z) = (%lg, %lg, %lg), Spread %lg\n",P->Par.me,i, R->LevSNo, WannierCentre[0], WannierCentre[1], WannierCentre[2], WannierCentre[NDIM]);
         for (j=0;j<NDIM;j++) Psi->AddData[OnePsiA->MyLocalNo].WannierCentre[j] = WannierCentre[j];
         Psi->AddData[OnePsiA->MyLocalNo].WannierSpread = WannierCentre[NDIM];
-        if (P->Call.out[ValueOut]) fprintf(stderr,"(%i) %s\t%lg\t%lg\t%lg\t\t%lg\n",P->Par.me, tagname,Psi->AddData[OnePsiA->MyLocalNo].WannierCentre[0],Psi->AddData[OnePsiA->MyLocalNo].WannierCentre[1],Psi->AddData[OnePsiA->MyLocalNo].WannierCentre[2],Psi->AddData[OnePsiA->MyLocalNo].WannierSpread);
+        //if (P->Par.me ==0 && P->Call.out[ValueOut]) fprintf(stderr,"(%i) %s\t%lg\t%lg\t%lg\t\t%lg\n",P->Par.me, tagname,Psi->AddData[OnePsiA->MyLocalNo].WannierCentre[0],Psi->AddData[OnePsiA->MyLocalNo].WannierCentre[1],Psi->AddData[OnePsiA->MyLocalNo].WannierCentre[2],Psi->AddData[OnePsiA->MyLocalNo].WannierSpread);
       } else if (P->Par.me_comm_ST == 0) { // if they are not local, yet we are process 0, send 'em to leader of its Psi group
         if (MPI_Send(WannierCentre, NDIM+1, MPI_DOUBLE, OnePsiA->my_color_comm_ST_Psi, ParseWannierTag, P->Par.comm_ST_PsiT) != MPI_SUCCESS)
@@ -1367,5 +1946,5 @@
   if ((SpreadFile != NULL) && (P->Par.me_comm_ST == 0)) 
     fclose(SpreadFile);
-  fprintf(stderr,"(%i) Parsing Wannier files succeeded!\n", P->Par.me);
+  //fprintf(stderr,"(%i) Parsing Wannier files succeeded!\n", P->Par.me);
   return 1;
 }
@@ -1408,21 +1987,6 @@
   b_ij = 0;
 
-  // create lookup table for sin/cos values
-  cos_lookup = (double **) Malloc(sizeof(double *)*NDIM, "ComputeMLWF: *cos_lookup");
-  sin_lookup = (double **) Malloc(sizeof(double *)*NDIM, "ComputeMLWF: *sin_lookup");
-  for (k=0;k<NDIM;k++) {
-    // allocate memory
-    cos_lookup[k] = (double *) Malloc(sizeof(double)*LevS->Plan0.plan->N[k], "ComputeMLWF: cos_lookup");
-    sin_lookup[k] = (double *) Malloc(sizeof(double)*LevS->Plan0.plan->N[k], "ComputeMLWF: sin_lookup");
-    // reset arrays
-    SetArrayToDouble0(cos_lookup[k],LevS->Plan0.plan->N[k]);
-    SetArrayToDouble0(sin_lookup[k],LevS->Plan0.plan->N[k]);
-    // create lookup values
-    for (g=0;g<LevS->Plan0.plan->N[k];g++) {
-      tmp = 2*PI/(double)LevS->Plan0.plan->N[k]*(double)g; 
-      cos_lookup[k][g] = cos(tmp);
-      sin_lookup[k][g] = sin(tmp);
-    }
-  }  
+  CreateSinCosLookupTable(&cos_lookup,&sin_lookup,N);
+
   // fill matrices
   OnePsiA = &Psi->AllPsiStatus[i];    // grab the desired OnePsiA
@@ -1499,12 +2063,7 @@
   // store spread in OnePsiElementAdd
   Psi->AddData[i].WannierSpread = B_ij - spread;
-  // free lookups
-  for (k=0;k<NDIM;k++) {
-    Free(cos_lookup[k], "bla");
-    Free(sin_lookup[k], "bla");
-  }
-  Free(cos_lookup, "bla");
-  Free(sin_lookup, "bla");
-
+
+  FreeSinCosLookupTable(cos_lookup,sin_lookup);
+  
   return (B_ij - spread);
 }
Index: pcp/src/wannier.h
===================================================================
--- pcp/src/wannier.h	(revision 9bdd866eca950981175d4eb672952e1c119b1d98)
+++ pcp/src/wannier.h	(revision 4f136930622a3ef24a8e10066443133f1c24c77c)
@@ -12,13 +12,41 @@
 
   File: wannier.h
-  $Id: wannier.h,v 1.8 2007/02/05 14:00:58 foo Exp $
+  $Id: wannier.h,v 1.3 2007-10-08 15:43:29 heber Exp $
 */
 
 #include <gsl/gsl_complex.h>
 
+/** Structure contains all variables needed for diagonalization of a matrix with 
+ * SerialDiagonalization() or ParallelDiagonalization()
+ */
+struct DiagonalizationData {
+  int Num;        //!< Number of rows/columns
+  int AllocNum;   //!< even number of rows/columns
+  int NumMatrices;//!< number of matrices to be simultaneously "actively" diagonalized
+  int extra;      //!< number of additional matrices that are also, yet "passively" diagonalized (not considered in rotation angle evaluation)
+  gsl_matrix *U;   //!< transformation matrix
+  gsl_matrix **A;  //!< matrix to be diagonlized
+  int *top;       //!< merry-go-round top row of indices
+  int *bot;       //!< merry-go-round bottom row of indices
+  MPI_Comm *comm; //!< MPI communicator for ParallelDiagonalization()
+  int ProcRank;   //!< Rank of this process, used in ParallelDiagonalization()
+  int ProcNum;    //!< Number of process in communicator, used in ParallelDiagonalization()
+};
+
+void PrintGSLMatrix(struct Problem *P, gsl_matrix *U, int Num, const char *msg);
 void ComputeMLWF(struct Problem *P);
+void WriteWannierFile(struct Problem *P, double spread, double old_spread, double **WannierCentre, double *WannierSpread);
 int ParseWannierFile(struct Problem *P);
+void SerialDiagonalization(struct Problem *P, struct DiagonalizationData *DiagData);
+void ParallelDiagonalization(struct Problem *P, struct DiagonalizationData *DiagData);
 double CalculateSpread(struct Problem *P, int i);
 gsl_complex convertComplex (fftw_complex a);
+void InitDiagonalization(struct Problem *P, struct DiagonalizationData *DiagData, int Num, int NumMatrices, int extra);
+void FreeDiagonalization(struct DiagonalizationData *DiagData);
+void OrthogonalizePsis(struct Problem *P);
+void StrongOrthogonalizePsis(struct Problem *P);
+void Diagonalize(struct Problem *P, struct DiagonalizationData *DiagData);
+
+void CalculateSecondOrderReciprocalMoment(struct Problem *P);
 
 #endif /*WANNIER_H_*/
